// #############################################################################################
//
// Legacy wrappers
// =============================================================================================
// 
// #############################################################################################





extern "C" HRESULT _LinkageDecl _stdcall Driver_Create (TagDriver * * Obj, GUID const * const ClassId);
extern "C" void _LinkageDecl _stdcall Driver_Delete (TagDriver * const Drv);
extern "C" bool _LinkageDecl _stdcall Driver_IsOpen (TagDriver const * const Drv);
extern "C" HRESULT _LinkageDecl _stdcall Driver_Open (TagDriver * const Drv);
extern "C" void _LinkageDecl _stdcall Driver_Close (TagDriver * const Drv);
extern "C" HRESULT _LinkageDecl _stdcall Driver_CreatePipe (TagDriver * const Drv, TagPipe * * Pipe, bool const Capture);





extern "C" bool _LinkageDecl _stdcall Pipe_IsCapt (TagPipe * const Pipe);
extern "C" bool _LinkageDecl _stdcall Pipe_IsOpen (TagPipe * const Pipe);
extern "C" PCTSTR _LinkageDecl _stdcall Pipe_GetType (TagPipe * const Pipe);

extern "C" bool _LinkageDecl _stdcall Pipe_IsRunningState (TagPipe * const Pipe);

extern "C" void _LinkageDecl _stdcall Pipe_Delete (TagPipe * const Pipe);

extern "C" HRESULT _LinkageDecl _stdcall Pipe_Open (TagPipe * const Pipe, PCTSTR const DriverInterface);
extern "C" void _LinkageDecl _stdcall Pipe_Close (TagPipe * const Pipe);

extern "C" _LinkageDecl CommonDataDesc * _stdcall Pipe_GetCommonData (TagPipe * const Pipe);

extern "C" HRESULT _LinkageDecl _stdcall Pipe_DriverRequest (
  TagPipe * const Pipe,
  UINT const Func,
  DriverReq * const Req, LocSize const ReqSize,
  void * const Data, LocSize const DataSize,
  LocSize * const RetSize
);

extern "C" HRESULT _LinkageDecl _stdcall Pipe_SetFormat (
  TagPipe * const Pipe, UINT const SR, UINT const BPS, UINT const NC, UINT const BPC, UINT const CC
);

extern "C" HRESULT _LinkageDecl _stdcall Pipe_SetMinimalBufferSize (TagPipe * const Pipe, UINT const Frames);
extern "C" HRESULT _LinkageDecl _stdcall Pipe_SetNotificationEvent (TagPipe * const Pipe, HANDLE const Event);

extern "C" HRESULT _LinkageDecl _stdcall Pipe_Notify (TagPipe * const Pipe, NTSTATUS const Code);

extern "C" HRESULT _LinkageDecl _stdcall Pipe_AdvanceDevicePosition (TagPipe * const Pipe, UINT const Frames);
extern "C" HRESULT _LinkageDecl _stdcall Pipe_ResetDevicePosition (TagPipe * const Pipe);





extern "C" bool _LinkageDecl _stdcall Host_IsCapt (TagHost * const Host);
extern "C" bool _LinkageDecl _stdcall Host_IsStarted (TagHost * const Host);
extern "C" PCTSTR _LinkageDecl _stdcall Host_GetType (TagHost * const Host);
extern "C" CommonDataDesc const * _LinkageDecl _stdcall Host_GetCommonData (TagHost * const Host);

extern "C" HRESULT _LinkageDecl _stdcall Host_Create (
  TagHost ** const Obj, TagDriver * const Drv, bool const Capture, CallbackInterface * const CB
);

extern "C" void _LinkageDecl _stdcall Host_Delete (TagHost * const Host);

extern "C" HRESULT _LinkageDecl _stdcall Host_Start (TagHost * const Host, WaveFormat const * const Format, UINT const MinBufMs);
extern "C" HRESULT _LinkageDecl _stdcall Host_Stop (TagHost * const Host);

extern "C" HRESULT _LinkageDecl _stdcall Host_EventLoop (TagHost * const Host, UINT const PollPeriodMs);
