inline void * _cdecl operator new (size_t const Bytes) {
  return (void *) (LocalAlloc (LPTR, Bytes));
}

inline void _cdecl operator delete (void *Block) {
  LocalFree (HLOCAL (Block));
}

bool IsBlank (wchar_t const c);

PTSTR FindBlank (PTSTR const p);

inline PCTSTR FindBlank (PCTSTR const p) {
  return PCTSTR (FindBlank (PTSTR (p)));
}

PCTSTR SkipBlank (PCTSTR const p);

PCTSTR GetQuotedString (PCTSTR const p, PTSTR const String);

int _cdecl strncmpi (PCTSTR const S1, PCTSTR const S2, size_t const Len);

bool DelFile (PCTSTR const Path);

bool GetPreferredDevice (bool const Out, PTSTR const Buffer);
bool SetPreferredDevice (bool const Out, PCTSTR const Name);

void TranslateSetupApiError (void);

void FlushStorage ();

HDEVINFO CreateDL (GUID const * const ClassGuid, DWORD const Flags);
void DestroyDL (HDEVINFO & DL);

bool GetRegistrySzValue (HKEY const Key, PCTSTR const Name, PTSTR const Value, DWORD const Size);

bool FindDeviceById (HDEVINFO const DL, SP_DEVINFO_DATA & DI, PCTSTR const HardwareId);

bool IsDevicePresent (PCTSTR const HardwareId);
bool CheckIfRebootRequired (HDEVINFO const DL, SP_DEVINFO_DATA const & DI, bool & RebootRequired);

bool EnableDevice (HDEVINFO const DL, SP_DEVINFO_DATA const & DI, bool const Enable);

bool StopDeviceDriverWithRetry (
  HDEVINFO DL, SP_DEVINFO_DATA const & DI, PCTSTR const DevName, PCTSTR const ServiceId
);

bool RemoveDevice (HDEVINFO const DL, SP_DEVINFO_DATA & DI, PCTSTR const InstanceId);
bool RemoveDriverPackage (PCTSTR const InfPath, bool & RestartRecommended);

SC_HANDLE OpenSystemService (PCTSTR const Name, UINT const SrvAccess, bool const MustExist = true);
bool GetServiceState (PCTSTR const Name, UINT & State);
bool WaitForServiceToStop (PCTSTR const Name, UINT const Sec);
bool RemoveService (PCTSTR const Name);
