__pragma (warning (disable:
  4480 // nonstandard extension used
  4514 // unref inline removed
  4710 // function not inlined
  4711 // selected for automatic inline expansion
  4820 // padding
  4996 // deprecated funcs
))

#if _MSC_VER >= 1800

  __pragma (warning (disable:
    4464 // relative include path contains '..'
    4625 // copy constructor was implicitly defined as deleted
    4626 // assignment operator was implicitly defined as deleted
    5026 // move constructor was implicitly defined as deleted
    5027 // move assignment operator was implicitly defined as deleted
    5045 // Compiler will insert Spectre mitigation for memory load if / Qspectre switch specified
  ))

#endif



#include "pfmdef.h"



#define _Debug (defined (_DEBUG))
#define _64BitEnv (defined (_WIN64))



#define _StrX(x) #x
#define _S(x) _StrX (x)



// Convert ANSI string literal to UNICODE

#define _UStrX2(x) L ## x
#define _UT(x) _UStrX2 (x)



#define SetBits(v,m) ((v) |= (m))
#define ClearBits(v,m) ((v) &= ~(m))
#define TestBits(e,m) ((e) & (m))



#if _MSC_VER < 1800

  #define nullptr 0

#endif


typedef void const * PCVOID;
typedef BYTE const * PCBYTE;
typedef ULONG NTSTATUS;



#ifndef STATUS_SUCCESS
  #define STATUS_SUCCESS (NTSTATUS (0))
#endif



#if _Debug

  #define Assert(Condition) \
    if (!(Condition)) { \
      __debugbreak (); \
    } else { \
    }

  #define AssertInRange(v, min, max) Assert (IsInRange (v, min, max))

  #define Verify Assert

  #define Debug(Level, ...) Dbg.Printf (Level, __VA_ARGS__)

#else

  #define Assert(Condition)
  #define AssertInRange(v, min, max)
  #define Verify(Condition) Condition

  #define Debug(Level, ...)

#endif



#define DebugPatch \
  __pragma (message (__FILE__ " (" _S (__LINE__) "): warning - DebugPatch in use! ####################")) \


#define FakeCopyConstructor(C) C (C const & Src);
#define FakeAssignmentOperator(C) void operator = (C const & Src);



#define NumArrayElems(a) (sizeof (a) / sizeof (*(a)))
#define SizeOfArray NumArrayElems
#define StrSzToLen(Size) ((Size) / sizeof (TCHAR))
#define StrLenToSz(Len) ((Len) * sizeof (TCHAR))
#define IsInRange(v, min, max) ((v) >= (min) && (v) <= (max))



#define While(Cond) \
  __pragma (warning (push)) \
  __pragma (warning (disable: 4127)) \
  while (Cond) \
  __pragma (warning (pop)) \

#define WhileFalse While (false)
#define OnlyOnce While (false)
#define WhileTrue While (true)
#define DoForever While (true)

#define Unreferenced(...) (void) (__VA_ARGS__)



#define ZeroObject(o) RtlZeroMemory (&(o), sizeof (o))



static HRESULT const E_I_PROCESSING_NOT_FINISHED = HRESULT (-1);





#include "resource.h"

#include "params.h"

#include "..\driver\driverapi.h"
using namespace ThinAudioGateway;

#include "..\apilib\userapi.h"
#include "..\apidll\legacyapi.h"

#include "utils.h"
#include "main.h"
